<template>
  <h1 class="text-xl font-bold leading-tight tracking-tight text-gray-900 md:text-2xl">
    Créer mon compte
  </h1>
  <UForm :schema="schema" :state="state" class="space-y-4 md:space-y-6" @submit="onSubmit">
    <UFormGroup label="Nom" name="name" class="block mb-2 text-sm font-medium !text-gray-900">
      <UInput type="text" v-model="state.username" placeholder="Jhon" inputClass="!bg-gray-50 !text-gray-900 sm:text-sm rounded-lg block w-full p-2.5" />
    </UFormGroup>
    <UFormGroup label="Email" name="email" class="block mb-2 text-sm font-medium !text-gray-900">
      <UInput type="email" v-model="state.email" placeholder="jhon@example.com" inputClass="!bg-gray-50 !text-gray-900 sm:text-sm rounded-lg block w-full p-2.5" />
    </UFormGroup>
    <UFormGroup label="Mot de passe" name="password" class="block mb-2 text-sm font-medium !text-gray-900">
      <UInput type="password" v-model="state.password" placeholder="••••••••" inputClass="!bg-gray-50 !text-gray-900 sm:text-sm rounded-lg block w-full p-2.5" />
    </UFormGroup>
    <div class="flex items-start">
      <div class="flex items-center h-5">
        <UCheckbox type="checkbox" v-model="state.terms" required />
      </div>
      <div class="ml-3 text-sm">
        <label for="terms" class="font-light text-gray-500">J'accepte <a class="font-medium text-primary-600 hover:underline" href="#">les termes et conditions</a></label>
      </div>
    </div>
    <p v-if="error" class="text-sm font-light text-red-500">{{ error }}</p>
    <UButton type="submit" :loading="loading" class="w-full text-white bg-primary-600 hover:bg-primary-700 focus:ring-4 focus:outline-none focus:ring-primary-300 font-medium rounded-lg text-sm px-5 py-2.5 text-center">
      Créer mon compte
    </UButton>
    <p class="text-sm font-light text-gray-500">
      Déjà un compte? <NuxtLink to="/login" class="font-medium text-primary-600 hover:underline">Me connecter ici</NuxtLink>
    </p>
  </UForm>
</template>
<script setup lang="ts">
import { object, string, boolean, type InferType } from 'yup'
import type { FormSubmitEvent } from '#ui/types'
import {useNuxtApp} from "#app";
import type {Api} from "~/types/api";
import {useAuthStore} from "~/store/auth";
import is from "@sindresorhus/is";
import undefined = is.undefined;


const loading = ref(false)
const error = ref('')


const schema = object({
  username: string().max(50, 'Le contenu est trop long').required('Champs obligatoire'),
  email: string().email('Email invalide').required('Champs obligatoire'),
  password: string()
      .min(8, 'Dois contenir au moins 8 caractères')
      .required('Champs obligatoire'),
  terms: boolean()
      .oneOf([true], 'Vous devez accepter les termes')
      .required('Vous devez accepter les termes')
})

type Schema = InferType<typeof schema>

const state = reactive({
  username: '',
  email: '',
  password: '',
  terms: false
})

const nuxtApp = useNuxtApp()
const $api = nuxtApp.$api as Api
const authStore = useAuthStore()
const { authenticated } = storeToRefs(useAuthStore())
const router = useRouter();

async function onSubmit (event: FormSubmitEvent<Schema>) {
  loading.value = true
  const data = ref({
    username: event.data.username,
    email: event.data.email,
    password: event.data.password
  })
  if (event.data.terms) {
    const response = await $api.register(data.value)
    if (response) {
      const user = ref({
        email: event.data.email,
        password: event.data.password
      })
      await authStore.authenticateUser(user.value)
      if (authenticated.value) {
        await router.push('/')
      }
    } else {
      error.value = 'Une erreur est survenue'
    }
  }
  loading.value = false
}
</script>